# Generate Address


## Requirements

{{ #include ../../../operator-requirements.md:requirements }}

{{ #include ../../../../../component-documents/linux-workstation.md:content }}

* [High Visibility Storage](TODO): plastic container or bag that's used to keep items while not in use in a visible location like the middle of a desk.

* [Quorum PGP key pairs](../../key-types.md#quorum-pgp-keypair) 

* [Ceremony SD card](../../ceremony-sd-card-provisioning.md)

## Procedure

1. Enter the designated location with the quorum of operators and all required equipment

1. Lock access to the location - there should be no inflow or outflow of people during the ceremony

1. Place Ceremony SD card in High Visibility Storage

1. Retrieve sealed Air-Gapped bundle, polaroid of tamper evidence, and online laptop from locked storage

{{ #include ../../../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-unsealing}}

1. Place all contents except for the laptop into High Visibility Storage

### Offline Machine: Generate Address

1. Retrieve AirgapOS SD card and plug it into the air-gapped machine

1. Turn on air-gapped machine

1. Unplug the AirgapOS SD card and place it in High Visibility Storage

1. Retrieve Ceremony SD card from High Visibility Storage and plug it into the air-gapped machine 

1. Copy the `vaults` repository to the machine and switch to it
    ```
	$ cp -r /media/vaults /root/
	$ cd /root/vaults
    ```

1. Start Keyfork using the relevant Shardfile:

	1. `keyfork recover shard --daemon <namespace>/shardfile.asc`

    1. Follow on screen prompts

1. If the desired `<coin>` directory doesn't exist for the namespace, create it:

    * `mkdir -p <namespace>/<coin>`

    * e.g `mkdir -p vault_1/sol/`

1. Connect to the appropriate coin directory:

    * `cd <namespace>/<coin>/`

1. Check what the latest address account is:

	* `ls -la .`

1. Find what the latest number for the address is, and add 1 to it. This will be the new address account.

	* For example if the latest address file is 42, the new account_id would be 43. The addresses should start at `0`

	* Set an environment variable with the new account_id:

		* `account_id=<num>`, e.g `account_id=43`

1. Generate a new address (replace `<coin>` with desired coin (`sol`, `cosmos`)):

    * `icepick workflow <coin> generate-address --account $account_id | jq -r .pubkey > $account_id.txt`
        * [38 removes need to use jq](https://git.distrust.co/public/icepick/issues/38)

1. Sign the file using:

    * Import OpenPGP keys:

        * `gpg --import /media/<device_name>/vaults/keys/all/*.asc`

    * `gpg --detach-sign $account_id.txt`

1. You may repeat the previous steps, starting at the step where the `account_id` is set.

1. Once finished, copy the updated repository back to the Ceremony SD card:

    * `cp -rf /root/vaults /media/`

1. Shut down the air gapped machine

1. Unplug the Ceremony SD card and place it into High Visibility Storage

1. Transfer the SD card from the air-gapped machine to the online machine

1. {{ #include ../../../../component-documents/finding-device-name.md:content }}

1. Copy the updated repository locally and switch to it:
	```
	$ cp -r /media/vaults ~/
	$ cd ~/vaults
	```
1. Stage, sign, commit and push the changes to the ceremonies repository:
	```
    $ git add <namespace>/ceremonies/<date>/payloads/*
	$ git commit -S -m "add payload signature for payload_<num>.json"
	$ git push origin main
	```

### Sealing

1. Gather all the original items that were in the air-gapped bundle:

    * Air-gapped computer

    * AirgapOS SD card

{{ #include ../../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-sealing}}

