# Generate Nonce Account

## Requirements

{{ #include ../../../../operator-requirements.md:requirements }}

{{ #include ../../../../../../component-documents/linux-workstation.md:content }}

* [High Visibility Storage](TODO): plastic container or bag that's used to keep items while not in use in a visible location like the middle of a desk.

* [Quorum PGP key pairs](../../key-types.md#quorum-pgp-keypair) 

* [Ceremony SD card](../../ceremony-sd-card-provisioning.md)

## Procedure

1. Turn on online machine

1. Make sure `jq` is installed:

    * `sudo apt install jq`

1. Clone the `vaults` repository if it's not available locally and get the latest changes:
	```
    $ cd ~
	$ git clone <repository_git_url>
	$ git pull origin main
	```

1. Ensure `keyfork` is available on the system:

    * Follow steps from [installation guide](https://git.distrust.co/public/keyfork#install)

1. Ensure `icepick` is available on system

    * Follow steps from [installation guide](TODO)

1. Set unsafe `keyfork` usage variable:

    * `export SHOOT_SELF_IN_FOOT=1`

1. Generate throwaway mnemonic to generate address which will be used for funding the creation of nonce account: 

    * `keyfork mnemonic generate | KEYFORK_PROMPT_TYPE=headless keyfork recover mnemonic --daemon`

1. Change directory into the desired \<namespace>/\<coin> directory:

    * `cd ~/vaults/<namespace>/<coin>`

1. Select which account you are creating the delegate address by viewing the appropriate \<namespace>/\<coin>/ directory:

    * `ls -la .`

1. Once you have selected the appropriate account, set the account_id variable:

    * `account_id=<num>`

1. Use `icepick` to generate nonce account:

    * The following command will need to be updated to use the appropriate \<cluster>, which can be `devnet`, `testnet` or `mainnet-beta` 

    * Set `icepick` config file:

        * `export ICEPICK_CONFIG_FILE=<path_to_icepick_repositry>/icepick.toml`

    * `icepick workflow sol generate-nonce-account  --authorization-address "$(cat $account_id.txt)" | jq -r .nonce_account > $account_id-na.txt`
        * [38 removes he need to use jq and cat](https://git.distrust.co/public/icepick/issues/38)

    * Repeat command if returned message is "The transaction was possibly not received by the cluster."

1. Airdrop the wallet displayed on-screen with 0.01 SOL

    * Once the airdrop is done, nonce account will be created

1. Stage, commit, sign and push the changes:
    ```
    $ git add .
    $ git commit -m -S "<message>"
    $ git push origin HEAD
    ```
### Sealing

1. Gather all the original items that were in the air-gapped bundle:

    * Air-gapped computer

    * AirgapOS SD card

{{ #include ../../../../../../component-documents/tamper-evidence-methods.md:vsbwf-procedure-sealing}}

